﻿EnableExplicit

XIncludeFile "modhaupt.pb"


Global frmHaupt,lstDaten, Event.l, Quit.b

Global PuffergroesseEingestellt.u=2048,PuffergroesseGeladen.u=0, *DatenspeicherBinaer, *DatenspeicherTmp


Enumeration FormMenu
  #mnu_Datei_Laden
  #mnu_Datei_Speichern
  #mnu_Datei_Programmende
  #mnu_Schnittstelle_LPT1
  #mnu_Schnittstelle_LPT2
  #mnu_Schnittstelle_LPT3
  #mnu_Eprom_2716
  #mnu_Eprom_2732
  #mnu_Eprom_2764
  #mnu_Eprom_27128
  #mnu_Eprom_Leertest
  #mnu_Eprom_Auslesen
  #mnu_Eprom_Vergleichen
  #mnu_Eprom_Schreiben
  #mnu_SN7474_00
  #mnu_SN7474_01
  #mnu_SN7474_10
  #mnu_SN7474_11
  
EndEnumeration

Declare.b EpromLeertest(von.u, bis.u)
Declare EpromLesen(von.u, bis.u, Meldung.b, Vergleichen.b)
Declare EpromSchreiben(von.u, bis.u)
Declare sn74ls74(Kanal1.b,Kanal2.b)
Declare Inaktiv()

Procedure OpenfrmHaupt()
  frmHaupt = OpenWindow(#PB_Any, 0, 0, 520, 600, "JU+TE Brenner", #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CreateStatusBar(0, WindowID(frmHaupt))
  AddStatusBarField(260)
  StatusBarText(0, 0, "Bereit", #PB_StatusBar_Raised)
  AddStatusBarField(130)
  StatusBarText(0, 1, "Eprom 2716", #PB_StatusBar_Raised)
  AddStatusBarField(130)
  StatusBarText(0, 2, "Puffer 0 Byte", #PB_StatusBar_Raised)
  CreateMenu(0, WindowID(frmHaupt))
  MenuTitle("Datei")
  MenuItem(#mnu_Datei_Laden, "Laden")
  MenuItem(#mnu_Datei_Speichern, "Speichern")
  MenuBar()
  OpenSubMenu("Schnittstelle")
  MenuItem(#mnu_Schnittstelle_LPT1, "LPT1 (&&H378)")
  MenuItem(#mnu_Schnittstelle_LPT2, "LPT2 (&&H278)")
  MenuItem(#mnu_Schnittstelle_LPT3, "LPT3 (&&H3BC)")
  CloseSubMenu()
  MenuBar()
  MenuItem(#mnu_Datei_Programmende, "Programm beenden")
  MenuTitle("Eprom")
  MenuItem(#mnu_Eprom_2716, "2716")
  MenuItem(#mnu_Eprom_2732, "2732")
  MenuItem(#mnu_Eprom_2764, "2764")
  MenuItem(#mnu_Eprom_27128, "27128")
  MenuBar()
  MenuItem(#mnu_Eprom_Leertest, "Leertest")
  MenuItem(#mnu_Eprom_Auslesen, "Auslesen")
  MenuItem(#mnu_Eprom_Vergleichen, "Vergleichen")
  MenuItem(#mnu_Eprom_Schreiben, "Schreiben")
  ;MenuTitle("SN7474")
  ;MenuItem(#mnu_SN7474_00, "00")
  ;MenuItem(#mnu_SN7474_01, "01")
  ;MenuItem(#mnu_SN7474_10, "10")
  ;MenuItem(#mnu_SN7474_11, "11")
  lstDaten = ListViewGadget(#PB_Any, 0, 0, 520, 550)
  SetGadgetFont(lstDaten,FontID(LoadFont(#PB_Any,"Courier",10)))
  ;AddGadgetItem(lstDaten,-1,"Hallo Welt!")
  SetMenuItemState(0,#mnu_Eprom_2716, 1)
  SetMenuItemState(0,#mnu_Schnittstelle_LPT1, 1)
  *DatenspeicherBinaer=AllocateMemory (2048) 
  *DatenspeicherTmp=AllocateMemory (2048) 
EndProcedure

Procedure frmHaupt_Events(event)
  Protected von.u,bis.u,tmp.s,i.u,zae.u,zeichen.s,a.a
  Select event
    Case #PB_Event_CloseWindow
      ProcedureReturn #False
    Case #PB_Event_Menu
      Select EventMenu()
        Case #mnu_SN7474_00
          sn74ls74(0,0)
        Case #mnu_SN7474_01
          sn74ls74(0,1)
        Case #mnu_SN7474_10
          sn74ls74(1,0)
        Case #mnu_SN7474_11
          sn74ls74(1,1)
        Case #mnu_Datei_Laden
          tmp = OpenFileRequester("Laden", "*.bin", "Binärdatei (*.bin)|*.bin|Alle Dateien (*.*)|*.*",0)
          If tmp <> ""
             If FileSize(tmp) = 0:MessageRequester("Fehler!","Datei ist leer, Abbruch!" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
             ;If FileSize(tmp) > 16384:MessageRequester("Fehler!","Datei ist zu groß, Abbruch!" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
             PuffergroesseGeladen=FileSize(tmp)
             *DatenspeicherBinaer=ReAllocateMemory(*DatenspeicherBinaer,PuffergroesseGeladen) 
             *DatenspeicherTmp=ReAllocateMemory(*DatenspeicherTmp,PuffergroesseGeladen) 
             StatusBarText(0,0,"Geladen: "+GetFilePart(tmp),#PB_StatusBar_Raised)
             StatusBarText(0,2,"Puffer "+Str(PuffergroesseGeladen)+" Byte",#PB_StatusBar_Raised)
             ReadFile(0,tmp)
             FileSeek(0,0) 
             ReadData(0,*DatenspeicherBinaer,Lof(0))
             CloseFile(0)                   
             bis=PuffergroesseGeladen-1
             ClearGadgetItems(lstDaten)
             tmp=""
             zeichen=""
             For i=0 To bis
                 a=PeekA(*DatenspeicherBinaer+i)
                 tmp=tmp+RSet(Hex(a), 2, "0")
                 If (a>31) And (a<127):zeichen=zeichen+Chr(a):Else:zeichen=zeichen+".":EndIf
                 zae=zae+1
                 If (zae=16) 
                     tmp=RSet(Hex((i-15)), 4, "0") + "|" + tmp
                     AddGadgetItem(lstDaten,-1,tmp+"|"+zeichen)
                     tmp=""
                     zeichen=""
                     zae=0
                 EndIf
             Next
             If Len(tmp)>0
                a=Len(tmp)/2
                tmp=LSet(tmp,32," ")
                tmp=RSet(Hex((i-a)), 4, "0") + "|" + tmp
                tmp=tmp+"|"+zeichen
                AddGadgetItem(lstDaten,-1,tmp)
             EndIf  
          EndIf
        Case #mnu_Datei_Speichern
          If CountGadgetItems(lstDaten) = 0: MessageRequester("Info","Es gibt nichts zu speichern!" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
          Select PuffergroesseEingestellt
            Case 2048:tmp="2716"
            Case 4096:tmp="2732"
            Case 8192:tmp="2764"
            Case 16384:tmp="27128"
          EndSelect
          tmp = SaveFileRequester("Speichern", tmp+".bin", "Binärdatei (*.bin)|*.bin|Alle Dateien (*.*)|*.*",0)
          If tmp <> ""
             If CreateFile(0,tmp)
                FileSeek(0,0)
                WriteData(0,*DatenspeicherBinaer,PuffergroesseGeladen)
                CloseFile(0)
                tmp=GetFilePart(tmp)
                MessageRequester("Info","Datei '"+tmp+"' wurde gespeichert."+Space(5),#PB_MessageRequester_Ok)
                ;Status
                StatusBarText(0,0,"Geladen: "+tmp,#PB_StatusBar_Raised)
             EndIf
          EndIf
        Case #mnu_Datei_Programmende
          ProcedureReturn #False
        Case #mnu_Schnittstelle_LPT1
          LPT_Daten = #LPT1_Daten
          LPT_Status = #LPT1_Status
          LPT_Steuer = #LPT1_Steuer
          LPT_ECP = #LPT1_ECP
          SetMenuItemState(0,#mnu_Schnittstelle_LPT1, 1)
          SetMenuItemState(0,#mnu_Schnittstelle_LPT2, 0)
          SetMenuItemState(0,#mnu_Schnittstelle_LPT3, 0)
        Case #mnu_Schnittstelle_LPT2
          LPT_Daten = #LPT2_Daten
          LPT_Status = #LPT2_Status
          LPT_Steuer = #LPT2_Steuer
          LPT_ECP = #LPT2_ECP
          SetMenuItemState(0,#mnu_Schnittstelle_LPT1, 0)
          SetMenuItemState(0,#mnu_Schnittstelle_LPT2, 1)
          SetMenuItemState(0,#mnu_Schnittstelle_LPT3, 0)
        Case #mnu_Schnittstelle_LPT3
          LPT_Daten = #LPT3_Daten
          LPT_Status = #LPT3_Status
          LPT_Steuer = #LPT3_Steuer
          LPT_ECP = #LPT3_ECP
          SetMenuItemState(0,#mnu_Schnittstelle_LPT1, 0)
          SetMenuItemState(0,#mnu_Schnittstelle_LPT2, 0)
          SetMenuItemState(0,#mnu_Schnittstelle_LPT3, 1)
        Case #mnu_Eprom_2716
          PuffergroesseEingestellt=2048
          SetMenuItemState(0,#mnu_Eprom_2716, 1)
          SetMenuItemState(0,#mnu_Eprom_2732, 0)
          SetMenuItemState(0,#mnu_Eprom_2764, 0)
          SetMenuItemState(0,#mnu_Eprom_27128, 0)
          StatusBarText(0, 1, "Eprom 2716", #PB_StatusBar_Raised)
        Case #mnu_Eprom_2732
          If MessageRequester("Warnung!","Ist der Brenner für Eproms des Typs 2732 ausgerüstet ?" + Space(5), #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
             PuffergroesseEingestellt=4096
             SetMenuItemState(0,#mnu_Eprom_2716, 0)
             SetMenuItemState(0,#mnu_Eprom_2732, 1)
             SetMenuItemState(0,#mnu_Eprom_2764, 0)
             SetMenuItemState(0,#mnu_Eprom_27128, 0)
             StatusBarText(0, 1, "Eprom 2732", #PB_StatusBar_Raised)
          EndIf      
        Case #mnu_Eprom_2764
          PuffergroesseEingestellt=8192
          SetMenuItemState(0,#mnu_Eprom_2716, 0)
          SetMenuItemState(0,#mnu_Eprom_2732, 0)
          SetMenuItemState(0,#mnu_Eprom_2764, 1)
          SetMenuItemState(0,#mnu_Eprom_27128, 0)
          StatusBarText(0, 1, "Eprom 2764", #PB_StatusBar_Raised)
        Case #mnu_Eprom_27128
          PuffergroesseEingestellt=16384
          SetMenuItemState(0,#mnu_Eprom_2716, 0)
          SetMenuItemState(0,#mnu_Eprom_2732, 0)
          SetMenuItemState(0,#mnu_Eprom_2764, 0)
          SetMenuItemState(0,#mnu_Eprom_27128, 1)
          StatusBarText(0, 1, "Eprom 27128", #PB_StatusBar_Raised)
        Case #mnu_Eprom_Leertest
          von = 0
          bis = PuffergroesseEingestellt-1
          Select PuffergroesseEingestellt
            Case 2048:tmp="2716"
            Case 4096:tmp="2732"
            Case 8192:tmp="2764"
            Case 16384:tmp="27128"
          EndSelect
          If MessageRequester("Frage ?", "Eprom '" + tmp + "' eingesetzt ?" + Space(5), #PB_MessageRequester_YesNo) <> #PB_MessageRequester_Yes: ProcedureReturn:EndIf
          WaitWindowEvent(1)
          If EpromLeertest(von, bis)=0
             MessageRequester("Info","Eprom ist leer !" + Space(5), #PB_MessageRequester_Ok)
          Else
             MessageRequester("Fehler!", "Eprom ist NICHT leer !" + Space(5), #PB_MessageRequester_Ok)
          EndIf
        Case #mnu_Eprom_Auslesen
          von = 0
          bis = PuffergroesseEingestellt-1
          Select PuffergroesseEingestellt
            Case 2048:tmp="2716"
            Case 4096:tmp="2732"
            Case 8192:tmp="2764"
            Case 16384:tmp="27128"
          EndSelect
          If MessageRequester("Frage ?", "Eprom '" + tmp + "' eingesetzt ?" + Space(5), #PB_MessageRequester_YesNo) <> #PB_MessageRequester_Yes: ProcedureReturn:EndIf
          WaitWindowEvent(1)
          *DatenspeicherBinaer=ReAllocateMemory(*DatenspeicherBinaer,PuffergroesseEingestellt) 
          *DatenspeicherTmp=ReAllocateMemory(*DatenspeicherTmp,PuffergroesseEingestellt) 
          EpromLesen(von,bis,1,0)
        Case #mnu_Eprom_Vergleichen
          von = 0
          bis = PuffergroesseEingestellt-1
          Select PuffergroesseEingestellt
            Case 2048:tmp="2716"
            Case 4096:tmp="2732"
            Case 8192:tmp="2764"
            Case 16384:tmp="27128"
          EndSelect
          If CountGadgetItems(lstDaten) = 0: MessageRequester("Info","Es gibt nichts zu vergleichen!" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
          If PuffergroesseEingestellt<>PuffergroesseGeladen: MessageRequester ("Abbruch!","Größe Pufferspeicher (" + Str(PuffergroesseGeladen) + " Byte) stimmt nicht mit Eprom '" + tmp + "' überein !" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
          If MessageRequester("Frage ?", "Eprom '" + tmp + "' eingesetzt ?" + Space(5), #PB_MessageRequester_YesNo) <> #PB_MessageRequester_Yes: ProcedureReturn:EndIf
          If PuffergroesseEingestellt<>PuffergroesseGeladen: MessageRequester ("Abbruch!","Größe Pufferspeicher (" + Str(PuffergroesseGeladen) + " Byte) stimmt nicht mit Eprom '" + tmp + "' überein !" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
          WaitWindowEvent(1)
          *DatenspeicherBinaer=ReAllocateMemory(*DatenspeicherBinaer,PuffergroesseEingestellt) 
          *DatenspeicherTmp=ReAllocateMemory(*DatenspeicherTmp,PuffergroesseEingestellt) 
          CopyMemory(*DatenspeicherBinaer,*DatenspeicherTmp,PuffergroesseEingestellt)
          EpromLesen (von, bis, 0, 1)
          If CompareMemory(*DatenspeicherBinaer,*DatenspeicherTmp,PuffergroesseEingestellt)
             MessageRequester("Info", "Pufferspeicher stimmt mit Eprom überein !" + Space(5), #PB_MessageRequester_Ok)
          Else
             If MessageRequester("Fehler!", "Pufferspeicher stimmt nicht mit Eprom überein !" + Space(5) + #CRLF$ + "Unterschiede jetzt anzeigen ?" + Space(5), #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
                zae = 0
                If CreateFile(0,"vergleich.txt")
                   WriteStringN(0,"Unterschiede zwischen Pufferspeicher und Eprom")
                   WriteStringN(0,"")
                   von=0
                   bis=PuffergroesseEingestellt-1
                   For i = von To bis
                       If PeekA(*DatenspeicherBinaer+i)<>PeekA(*DatenspeicherTmp+i)
                           WriteString (0, "Adresse= &H" + RSet(Hex(i), 4,"0") + " Puffer= &H" )
                           WriteString (0, RSet(Hex(PeekA(*DatenspeicherTmp+i)), 2,"0") + " Eprom= &H")
                           WriteStringN (0, RSet(Hex(PeekA(*DatenspeicherBinaer+i)), 2,"0"))
                           zae=zae+1
                       EndIf
                   Next
                   WriteStringN(0,"")
                   WriteStringN(0, Str(zae) + " Unterschiede gefunden !")
                   CloseFile(0)
                   RunProgram("notepad.exe" , "vergleich.txt", "")
                EndIf
             EndIf  
          EndIf
          ;Zurückspeiben des Pufferspeichers
          CopyMemory(*DatenspeicherTmp,*DatenspeicherBinaer,PuffergroesseEingestellt)
        Case #mnu_Eprom_Schreiben
          von = 0
          bis = PuffergroesseGeladen-1
          Select PuffergroesseEingestellt
            Case 2048:tmp="2716"
            Case 4096:tmp="2732"
            Case 8192:tmp="2764"
            Case 16384:tmp="27128"
          EndSelect
          If CountGadgetItems(lstDaten) = 0: MessageRequester("Info","Es gibt nichts zu schreiben!" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
          If PuffergroesseEingestellt<PuffergroesseGeladen: MessageRequester ("Abbruch!","Pufferspeicher (" + Str(PuffergroesseGeladen) + " Byte) ist größer als Eprom '" + tmp + "'!" + Space(5), #PB_MessageRequester_Ok):ProcedureReturn:EndIf
          tmp = "Eprom '" + tmp + "' eingesetzt?" + Space(5) + #CRLF$
          tmp=tmp+"Richtige Programmierspannung angelegt?" + Space(5)
          If PuffergroesseEingestellt=2048
             tmp=tmp+#CRLF$+"Schalter auf '16' gestellt?" + Space(5)
          EndIf
          If PuffergroesseEingestellt=4096
             tmp=tmp+#CRLF$+"Schalter auf '32' gestellt?" + Space(5)
          EndIf
          If MessageRequester("Frage?",tmp, #PB_MessageRequester_YesNo) <> #PB_MessageRequester_Yes:ProcedureReturn:EndIf
          WaitWindowEvent(1)
          EpromSchreiben (von, bis)
      EndSelect
    Case #PB_Event_Gadget
      Select EventGadget()
      EndSelect
  EndSelect
  ProcedureReturn #True
EndProcedure

Procedure Pause()
  Protected i.l
  ;For i = 0 To 999
    
  ;Next
EndProcedure


Procedure sn74ls74(Kanal1.b,Kanal2.b)
  Protected a.a,Steuer.a, Wert.a
  ;Bidirektional einschalten
  Steuer = Inp(LPT_ECP)
  Steuer = BitSetzen (Steuer, 5)
  Out (LPT_ECP, Steuer)
  
  
  a = Inp(LPT_Steuer)
  a = BitLoeschen (a, 5)     ;Datentor auf Ausgabe
  a = BitSetzen (a, 2)     ;74
  Out (LPT_Steuer, a)
  
  Wert=$00
  If Kanal1=1 : Wert=Wert+128:EndIf
  If Kanal2=1 : Wert=Wert+64:EndIf
  
  Out (LPT_Daten, Wert)
  
  ;Ausgang 5, Bitfolge 101  
  a = BitLoeschen (a, 2)       ;74
  Out (LPT_Steuer, a)
  Pause()
  a = BitSetzen (a, 2)       ;74
  Out (LPT_Steuer, a)

  
  Inaktiv()
  
  a = Inp(LPT_Steuer)
  a = BitSetzen (a, 5)     ;Datentor auf Eingabe
  Out (LPT_Steuer, a)
  
  ;Bidirektional abschalten
  Steuer = BitLoeschen (Steuer, 5)
  Out (LPT_ECP, Steuer)
EndProcedure


Procedure Inaktiv()
  Protected a.a
  a = Inp(LPT_Steuer)
  a = BitLoeschen (a, 3)     ;36
  Out (LPT_Steuer, a)
EndProcedure
 
  
Procedure AdresseAnlegen(Adresse.u, Brennen.b=0)
  Protected a.a, bo.a, bu.a
  bu = AdresseTeilen(Adresse, 0)
  bo = AdresseTeilen(Adresse, 1)
  ;MsgBox Hex(Adresse) + "-" + Hex(bo) + "-" + Hex(bu)
  
  ;***
  ;a = Inp(LPT_Steuer)
  ;a = BitLoeschen (a, 3)     ;36 - Schaltung inaktiv
  Inaktiv()
  
  a = Inp(LPT_Steuer)
  a = BitLoeschen (a, 5)     ;Datentor auf Ausgabe
  Out (LPT_Steuer, a)
  Pause ()               ;Pause
  Out (LPT_Daten, bu) ;unteren Teil der Adresse anlegen
  ;MsgBox "au"
  Pause ()               ;Pause
  a = BitLoeschen (a, 0)     ;34
  a = BitLoeschen (a, 1)     ;35
  a = BitSetzen (a, 3)       ;36
  Out (LPT_Steuer, a)
  Pause ()               ;Pause
  
  ;****
  ;a = BitLoeschen (a, 3)     ;36 - Schaltung inaktiv
  ;Out (LPT_Steuer, a)
  Inaktiv()
  
  
  ;MsgBox "au 2"
  Pause ()               ;Pause
  ;Steuersignale aufbereiten
  ;/CE
  bo = BitLoeschen (bo, 7)
  bo = BitLoeschen (bo, 5)
      
  If PuffergroesseEingestellt<=4096      ;nur 2716/32
     bo = BitSetzen (bo, 6)   ;2716/32 VCC
     If Brennen = 1
        bo = BitSetzen (bo, 5)
        If PuffergroesseEingestellt = 2048: bo = BitSetzen (bo, 7):EndIf
     EndIf
     If PuffergroesseEingestellt = 2048: bo = BitSetzen (bo, 3):EndIf
     ;If PuffergroesseEingestellt = 4096:bo=BitLoeschen(bo,3):EndIf
  EndIf
  
  If PuffergroesseEingestellt=16384
     If Adresse>=8192
        bo = BitSetzen (bo, 6)  ;27128 obere 8k
     Else   
        bo = BitLoeschen (bo, 6)  ;27128 untere 8k
     EndIf 
  EndIf
  
  Out (LPT_Daten, bo) ;oberen Teil der Adresse anlegen
  ;MsgBox "ao"
  Pause ()               ;Pause
  a = Inp(LPT_Steuer)
  a = BitLoeschen (a, 0)     ;34
  a = BitSetzen (a, 1)       ;35
  a = BitSetzen (a, 3)       ;36
  Out (LPT_Steuer, a)
  Pause ()               ;Pause
  
  ;***
  ;a = BitLoeschen (a, 3)     ;36 - Schaltung inaktiv
  ;Out (LPT_Steuer, a)
  Inaktiv()
  
  
  ;MsgBox "ao 2"
  Pause ()               ;Pause
EndProcedure
 
Procedure.b EpromLeertest(von.u, bis.u)
  Protected a.a, i.u, c.u, Steuer.a, Fehler.b
  ;Bidirektional einschalten
  Steuer = Inp(LPT_ECP)
  Steuer = BitSetzen (Steuer, 5)
  Out (LPT_ECP, Steuer)
  Fehler = 0
  For i = von To bis
      AdresseAnlegen (i)
      ;Debug RSet(Bin(inp(LPT_Steuer)),8,"0")
      StatusBarText(0,0,"Teste Adresse &H" + RSet(Hex(i),4,"0"),#PB_StatusBar_Raised)
      ;Lesen vorbereiten
      a = Inp(LPT_Steuer)
      a = BitSetzen (a, 5)       ;Datentor auf Eingabe
      a = BitSetzen (a, 0)       ;34
      a = BitLoeschen (a, 1)     ;35
      a = BitSetzen (a, 3)       ;36
      Out (LPT_Steuer, a)
      WaitWindowEvent(1)
      ;Pause()                ;Pause
      ;Debug inp(LPT_Daten)
      ;If i>15:Break:EndIf
      If Inp(LPT_Daten) <> 255: Fehler = 1: Break:EndIf
  Next
  ;--- Adresse Nullen
  ;--- Sichern eingestellten Eprom
  c=PuffergroesseEingestellt  
  ;--- Epromtyp 128 wählen
  PuffergroesseEingestellt=16384  
  ;--- Adresse
  AdresseAnlegen (0)
  ;--- Epromtyp wiederherstellen
  PuffergroesseEingestellt=c
  
  ;***
  ;a = Inp(LPT_Steuer)
  ;a = BitLoeschen (a, 3)     ;36 - Schaltung inaktiv
  ;Out (LPT_Steuer, a)
  Inaktiv()
  
  ;Bidirektional abschalten
  Steuer = BitLoeschen (Steuer, 5)
  Out (LPT_ECP, Steuer)
  StatusBarText(0,0,"Bereit",#PB_StatusBar_Raised)
  ProcedureReturn Fehler  
EndProcedure

Procedure EpromLesen(von.u, bis.u, Meldung.b, Vergleichen.b)
  Protected a.a, i.u, c.a, Steuer.a, d.u, z.u, tmp.s, puffer.s, zeichen.s
  ;Bidirektional einschalten
  Steuer = Inp(LPT_ECP)
  Steuer = BitSetzen (Steuer, 5)
  Out (LPT_ECP, Steuer)
  d = von
  z = 0
  tmp = ""
  puffer=""
  zeichen=""
  ;DatenspeicherBinaer = ""
  If Vergleichen = 0 : ClearGadgetItems(lstDaten):EndIf
  
  For i = von To bis
      tmp="Lese von"
      If Vergleichen=1 : tmp="Vergleiche" :EndIf
      StatusBarText(0,0,tmp+" Adresse &H" + RSet(Hex(i),4,"0"),#PB_StatusBar_Raised)
      AdresseAnlegen (i)
      ;Lesen vorbereiten
      a = Inp(LPT_Steuer)
      a = BitSetzen (a, 5)    ;Datentor auf Eingabe
      a = BitSetzen (a, 0)    ;34
      a = BitLoeschen (a, 1)  ;35
      a = BitSetzen (a, 3)    ;36
      Out (LPT_Steuer, a)
      ;Sleep 1
      WaitWindowEvent(1)
      ;Pause ()
      c = Inp(LPT_Daten)
      PokeA(*DatenspeicherBinaer+i,c)
      puffer = puffer + RSet(Hex(c), 2, "0")
      If (c>31) And (c<127):zeichen=zeichen+Chr(c):Else:zeichen=zeichen+".":EndIf
      z = z + 1
      If (z = 16) 
          If Vergleichen = 0
             puffer = RSet(Hex((i-15)), 4, "0") + "|" + puffer
             ;txtDaten.Text = txtDaten.Text + tmp + vbCrLf
             AddGadgetItem(lstDaten,-1,puffer+"|"+zeichen)
             puffer = ""
             zeichen=""
             z = 0
          EndIf
      EndIf
      Pause ()    ;Pause
  Next
  ;--- Adresse Nullen
  ;--- Sichern eingestellten Eprom
  d=PuffergroesseEingestellt
  PuffergroesseEingestellt=16384
  ;--- Adresse
  AdresseAnlegen(0)
  ;--- Epromtyp wiederherstellen
  PuffergroesseEingestellt=d
  
  ;***
  ;a=BitLoeschen(a, 3)   ;36 - Schaltung inaktiv
  ;Out (LPT_Steuer, a)
  Inaktiv()
  
  ;Bidirektional abschalten
  Steuer=BitLoeschen(Steuer, 5)
  Out (LPT_ECP, Steuer)
  PuffergroesseGeladen=PuffergroesseEingestellt
  StatusBarText(0,0,"Bereit",#PB_StatusBar_Raised)
  StatusBarText(0,2,"Puffer "+Str(PuffergroesseEingestellt)+" Byte",#PB_StatusBar_Raised)
  tmp="ausgelesen"
  If Vergleichen = 1 : tmp="verglichen":EndIf
  If Meldung=1:MessageRequester("Info","Eprom wurde "+tmp+"." + Space(5), #PB_MessageRequester_Ok):EndIf

EndProcedure

Procedure EpromSchreiben(von.u, bis.u)
  Protected a.a, i.u, c.a, d.a, Steuer.a, z.u, Fehler.b, tmp.s
  ;Bidirektional einschalten
  Steuer=Inp(LPT_ECP)
  Steuer=BitSetzen(Steuer, 5)
  Out (LPT_ECP, Steuer)
  Fehler=0
  For i=von To bis
      z = 0
      ;ist nach unten gewandert !
      ;AdresseAnlegen i, True
      StatusBarText(0,0,"Schreibe auf Adresse &H" + RSet(Hex(i),4,"0"),#PB_StatusBar_Raised)
      WaitWindowEvent(1)
      d=PeekA(*DatenspeicherBinaer+i)
      If d=$ff:Goto NOP:EndIf
Versuch:
      ;In den Schreibmodus !
      AdresseAnlegen(i, 1)
      ;Schreiben vorbereiten
      a=Inp(LPT_Steuer)
      a=BitLoeschen(a, 5)       ;Datentor auf Ausgabe
      Out (LPT_Steuer, a)
      ;Daten anlegen
      Out (LPT_Daten, d)
      ;Schreiben
      a=BitSetzen (a, 0)       ;34
      a=BitSetzen (a, 1)       ;35
      a=BitSetzen (a, 3)       ;36
      Out (LPT_Steuer, a)
      z = z + 1
      WaitWindowEvent (1)              ;1 ms warten
      AdresseAnlegen (i)     ;Lesen
      Pause()
      a=BitSetzen (a, 5)       ;Datentor auf Eingabe
      a=BitSetzen (a, 0)       ;34
      a=BitLoeschen (a, 1)     ;35
      a=BitSetzen (a, 3)       ;36
      Out (LPT_Steuer, a)
      ;Einlesen
      c = Inp(LPT_Daten)
      If z > 50: Fehler=1: Break:EndIf
      If c <> d :Goto Versuch:EndIf
      ;Zurück in den Schreibmodus !
      AdresseAnlegen (i, 1)
      ;Nachbrennen
      a=BitLoeschen (a, 5)     ;Datentor auf Ausgabe
      Out (LPT_Steuer, a)
      ;Daten anlegen
      Out (LPT_Daten, d)
      ;Schreiben
      a=BitSetzen (a, 0)       ;34
      a=BitSetzen (a, 1)       ;35
      a=BitSetzen (a, 3)       ;36
      Out (LPT_Steuer, a)
      WaitWindowEvent(2)              ;2 ms warten
      ;Passiv
      a=BitLoeschen (a, 3)     ;36
      Out (LPT_Steuer, a)
      Pause()                 ;Pause
NOP:
  Next
  ;--- Adresse Nullen
  ;--- Sichern eingestellten Eprom
  z=PuffergroesseEingestellt
  PuffergroesseEingestellt=16384  
  ;--- Adresse
  AdresseAnlegen (0)
  ;--- Epromtyp wiederherstellen
  PuffergroesseEingestellt=z
  
  ;***
  ;a=BitLoeschen (a, 3)     ;36 - Schaltung inaktiv
  ;Out (LPT_Steuer, a)
  Inaktiv()
  
  
  ;Bidirektional abschalten
  Steuer=BitLoeschen (Steuer, 5)
  Out (LPT_ECP, Steuer)
  ;--
  If Fehler=0
     MessageRequester ("Info","Eprom erfolgreich geschrieben." + Space(5), #PB_MessageRequester_Ok)
  Else
     MessageRequester("Fehler!", "Schreiben Eprom fehlgeschlagen!" + Space(5), #PB_MessageRequester_Ok)
  EndIf
  ;Status wiederherstellen
   StatusBarText(0,0,"Bereit",#PB_StatusBar_Raised)
EndProcedure




OpenfrmHaupt()


 Repeat
    Event=WaitWindowEvent()
    If frmHaupt_Events(event)=#False:Quit=1:EndIf
    If Event = #PB_Event_CloseWindow  ; If the user has pressed on the close button
      Quit = 1
    EndIf
  Until Quit = 1
  
  
  ;inpoutx64.dll freigeben
  CloseLibrary(0)
  
  FreeMemory(*DatenspeicherBinaer)
  FreeMemory(*DatenspeicherTmp)

  
End   


; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 73
; FirstLine = 47
; Folding = H5
; EnableUnicode
; EnableXP
; UseIcon = JUTEBRENNER.ICO
; Executable = jutebrenner.exe
; CompileSourceDirectory
; EnableCompileCount = 118
; EnableBuildCount = 2